﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataGridDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        ProgramRepository program;
        public ViewModel()
        {
            program = new ProgramRepository();
            SetRowstoGenerate(50);
        }

        #region ItemsSource

        private ObservableCollection<Program> allPrograms;

        public ObservableCollection<Program> AllPrograms
        {
            get { return allPrograms; }
            set { this.allPrograms = value; RaisePropertyChanged("AllPrograms"); }
        }

        #endregion

        private Program selectedItem;

        public Program SelectedItem
        {
            get { return selectedItem; }
            set
            {
                if (value != null)
                {
                    selectedItem = value;
                    RaisePropertyChanged("SelectedItem");
                }

            }
        }

        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            allPrograms = program.GetProgramDetails(count);
            selectedItem = allPrograms[1];
        }

        #endregion

        #region INotifyPropertyChanged implementation

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
